# IRpKernel Interface Reference

Inherits IRsObject, and IRsObject.

List of all members.

## Public Member Functions
HRESULT | ImportPackage ([in] BSTR inPackageFile)
HRESULT | RegisterPackage ([in] IRsUnknownPackage *pPackage)
HRESULT | UnRegisterPackage ([in] IRsUnknownPackage *pPackage)
HRESULT | FindPackage ([in] GUID id,[out, retval] IRsUnknownPackage **ppPackage)
HRESULT | GetPackageModuleInstance ([in] GUID id,[out, retval] RtInstance *pInstance)
HRESULT | GetPackageResourceInstance ([in] GUID id,[out, retval] RtInstance *pInstance)
HRESULT | EnumeratePackages ([out, retval]IRsEnumPackage **ppEnumPackage)
HRESULT | GetPackageFileName ([in] IRsUnknownPackage *spUnkPackage,[out, retval] BSTR *pbszFileName)
HRESULT | IsShuttingDown ([out, retval] RtBool *bShuttingDown)
HRESULT | ShutDown (void)
HRESULT | Run ([in] BSTR szInitScript)
HRESULT | SendMessage ([in] MSGID msgId,[in] IRsUnknownMsg *pMsg)
HRESULT | ContextDestroy (void)
HRESULT | GetSysFactory ([out, retval] IRsSysFactory **ppFactory)
HRESULT | GetSysCore ([out, retval] IRsSysCore **ppSysCore)
HRESULT | GetSysPersist ([out, retval] IRsSysPersist **ppSysPersist)
HRESULT | GetSysScanner ([out, retval] IRsSysScanner **pSysScanner)
HRESULT | GetLogger ([out, retval] IRsLogger **ppLogger)
HRESULT | GetKernelNode ([out, retval] IRnKernel **pNode)
HRESULT | SetKernelNode ([in] IRsNode *pNode)
HRESULT | GetSelectionManager ([out, retval] IRsSelectionManager **ppSelMng)
HRESULT | GetNodeSelection ([in] IRsSelectionNotification *pNotify,[out, retval] IRdSelNodeSelection **ppSelection)
HRESULT | GetAcceleratorHandlerManager ([out, retval] IRsAcceleratorHandlerManager **ppManager)
HRESULT | GetGlobalAcceleratorHandler ([out, retval] IRsAcceleratorHandlerGlobal **ppHandler)
HRESULT | GetKernelFactory ([out, retval] IRsKernelFactory **ppFactory)
HRESULT | GetPluginManager ([out, retval] IRsPluginManager **ppPluginMng)
HRESULT | AddPackageLoadPath ([in] BSTR bsPath,[in] BOOL bInsertToFront)
HRESULT | CreateBaseNode ([in] IUnknown *pOuter,[out, retval] IUnknown **ppBaseNode)
HRESULT | CreateEncapsulator ([in] IUnknown *pOuter,[out, retval] IUnknown **ppEncapsulator)
HRESULT | CreateEventLogSession ([out, retval] IRsEventLogSession **ppLogSession)
HRESULT | CreateBaseFnSet ([in] IUnknown *pOuter,[out, retval] IUnknown **ppBaseSet)
HRESULT | CreateKernelFnSet ([in] IUnknown *pOuter,[out, retval] IRfKernelSet **ppFn)
HRESULT | CreateEncapsulatorFnSet ([out, retval] IRfEncapsulatorSet **ppFn)
HRESULT | CreateSystemNamedItem ([out, retval] IUnknown **ppFn)
HRESULT | CreateBSEventFn ([out, retval] IRfBSEventFn **ppEventFn)
HRESULT | CreateEncapsIt ([out, retval] IRsEncapsIt **ppIt)
HRESULT | CreateNodeFilter ([out, retval] IRsNodeFilter **ppNodeFilter)
HRESULT | CreateConnectionHelper ([out, retval] IRfConnection **ppConHelper)
HRESULT | ImportPackage ([in] BSTR inPackageFile)
HRESULT | RegisterPackage ([in] IRsUnknownPackage *pPackage)
HRESULT | UnRegisterPackage ([in] IRsUnknownPackage *pPackage)
HRESULT | FindPackage ([in] GUID id,[out, retval] IRsUnknownPackage **ppPackage)
HRESULT | GetPackageModuleInstance ([in] GUID id,[out, retval] RtInstance *pInstance)
HRESULT | GetPackageResourceInstance ([in] GUID id,[out, retval] RtInstance *pInstance)
HRESULT | EnumeratePackages ([out, retval]IRsEnumPackage **ppEnumPackage)
HRESULT | GetPackageFileName ([in] IRsUnknownPackage *spUnkPackage,[out, retval] BSTR *pbszFileName)
HRESULT | IsShuttingDown ([out, retval] RtBool *bShuttingDown)
HRESULT | ShutDown (void)
HRESULT | Run ([in] BSTR szInitScript)
HRESULT | SendMessage ([in] MSGID msgId,[in] IRsUnknownMsg *pMsg)
HRESULT | ContextDestroy (void)
HRESULT | GetSysFactory ([out, retval] IRsSysFactory **ppFactory)
HRESULT | GetSysCore ([out, retval] IRsSysCore **ppSysCore)
HRESULT | GetSysPersist ([out, retval] IRsSysPersist **ppSysPersist)
HRESULT | GetSysScanner ([out, retval] IRsSysScanner **pSysScanner)
HRESULT | GetLogger ([out, retval] IRsLogger **ppLogger)
HRESULT | GetKernelNode ([out, retval] IRnKernel **pNode)
HRESULT | SetKernelNode ([in] IRsNode *pNode)
HRESULT | GetSelectionManager ([out, retval] IRsSelectionManager **ppSelMng)
HRESULT | GetNodeSelection ([in] IRsSelectionNotification *pNotify,[out, retval] IRdSelNodeSelection **ppSelection)
HRESULT | GetAcceleratorHandlerManager ([out, retval] IRsAcceleratorHandlerManager **ppManager)
HRESULT | GetGlobalAcceleratorHandler ([out, retval] IRsAcceleratorHandlerGlobal **ppHandler)
HRESULT | GetKernelFactory ([out, retval] IRsKernelFactory **ppFactory)
HRESULT | GetPluginManager ([out, retval] IRsPluginManager **ppPluginMng)
HRESULT | AddPackageLoadPath ([in] BSTR bsPath,[in] BOOL bInsertToFront)
HRESULT | CreateBaseNode ([in] IUnknown *pOuter,[out, retval] IUnknown **ppBaseNode)
HRESULT | CreateEncapsulator ([in] IUnknown *pOuter,[out, retval] IUnknown **ppEncapsulator)
HRESULT | CreateEventLogSession ([out, retval] IRsEventLogSession **ppLogSession)
HRESULT | CreateBaseFnSet ([in] IUnknown *pOuter,[out, retval] IUnknown **ppBaseSet)
HRESULT | CreateKernelFnSet ([in] IUnknown *pOuter,[out, retval] IRfKernelSet **ppFn)
HRESULT | CreateEncapsulatorFnSet ([out, retval] IRfEncapsulatorSet **ppFn)
HRESULT | CreateSystemNamedItem ([out, retval] IUnknown **ppFn)
HRESULT | CreateBSEventFn ([out, retval] IRfBSEventFn **ppEventFn)
HRESULT | CreateEncapsIt ([out, retval] IRsEncapsIt **ppIt)
HRESULT | CreateNodeFilter ([out, retval] IRsNodeFilter **ppNodeFilter)
HRESULT | CreateConnectionHelper ([out, retval] IRfConnection **ppConHelper)
## Properties
IRsUnknownRunner ** | DefaultRunner`[get]`
IRsUnknownRunner * | DefaultRunner`[set]`
IRsUnknownRunner ** | DefaultRunner`[get]`
IRsUnknownRunner * | DefaultRunner`[set]`

## Detailed Description

Kernel package interface.

## Member Function Documentation

HRESULT IRpKernel::ImportPackage | ( | [in] BSTR | inPackageFile | ) |

ImportPackage Imports specified package into system.

- It creates package instance, initializes and then registers it in the kernel.

Parameters:

  | inPackageFile | [in] File name of package.

HRESULT IRpKernel::RegisterPackage | ( | [in] IRsUnknownPackage * | pPackage | ) |

RegisterPackage Registers specified package in the kernel.

Parameters:

  | pPackage | [in] Interface to package object.

HRESULT IRpKernel::UnRegisterPackage | ( | [in] IRsUnknownPackage * | pPackage | ) |

UnRegisterPackage Removes registered package from the kernel.

Parameters:

  | pPackage | [in] Interface to package object.

HRESULT IRpKernel::FindPackage | ( | [in] GUID | id,
|  | [out, retval] IRsUnknownPackage ** | ppPackage |
| ) |  |  |

FindPackage

Searches for registered package by its GUID (i.e. DEF_GUIDNAME(CRpFileIOPck)).

Parameters:

  | id | [in] Unique identification of registered package.

Returns:
  ppPackage [out,retval] Interface to package object.

HRESULT IRpKernel::GetPackageModuleInstance | ( | [in] GUID | id,
|  | [out, retval] RtInstance * | pInstance |
| ) |  |  |

GetPackageModuleInstance

Finds package and returns its module instance.

Parameters:

  | id | [in] Unique identification of registered package.

Returns:
  pInstance [out,retval] Handle to module instance.

HRESULT IRpKernel::GetPackageResourceInstance | ( | [in] GUID | id,
|  | [out, retval] RtInstance * | pInstance |
| ) |  |  |

GetPackageResourceInstance

Finds package and returns its resource instance.

Parameters:

  | id | [in] Unique identification of registered package.

Returns:
  pInstance [out,retval] Handle to resource instance of the package.

HRESULT IRpKernel::EnumeratePackages | ( | [out, retval] IRsEnumPackage ** | ppEnumPackage | ) |

EnumeratePackages

Returns the package enumerator.

Returns:
  ppEnumPackage [out,retval] Interface to the package enumerator object.

HRESULT IRpKernel::GetPackageFileName | ( | [in] IRsUnknownPackage * | spUnkPackage,
|  | [out, retval] BSTR * | pbszFileName |
| ) |  |  |

GetPackageFileName

Returns filename of specified package.

Parameters:

  | spUnkPackage | [in] Unique identification of registered package.

Returns:
  pbszPackageName [out,retval] Filename of package.

HRESULT IRpKernel::IsShuttingDown | ( | [out, retval] RtBool * | bShuttingDown | ) |

IsShuttingDown

Returns true if system is being shut down.

Returns:
  bShuttingDown [out,retval] Set true if system is shutdowning otherwise false.

HRESULT IRpKernel::ShutDown | ( | void |  | ) |

ShutDown

Runs system shutdown sequence.

HRESULT IRpKernel::Run | ( | [in] BSTR | szInitScript | ) |

Run

Starts kernel with specified startup script.

Parameters:

  | szInitScript | [in] Initialization script command.

HRESULT IRpKernel::SendMessage | ( | [in] MSGID | msgId,
|  | [in] IRsUnknownMsg * | pMsg |
| ) |  |  |

SendMessage

Sends the system message to all registered packages.

Parameters:

  | msgId | [in] Message identification.
  | pMsg | [in] Custom message data.

HRESULT IRpKernel::ContextDestroy | ( | void |  | ) |

ContextDestroy

Destroys current context.

- It destroys whole object-contraint graph including the kernel node.

HRESULT IRpKernel::GetSysFactory | ( | [out, retval] IRsSysFactory ** | ppFactory | ) |

GetSysFactory

Returns interface to the System Factory.

Returns:
  ppFactory [out,retval] Interface to the System factory object.

HRESULT IRpKernel::GetSysCore | ( | [out, retval] IRsSysCore ** | ppSysCore | ) |

GetSysCore

Returns interface to the System Core.

Returns:
  ppSysCore [out,retval] Interface to the System Core object.

HRESULT IRpKernel::GetSysPersist | ( | [out, retval] IRsSysPersist ** | ppSysPersist | ) |

GetSysScanner

Returns interface to System Persist.

Returns:
  ppSysPersist [out,retval] Interface to the System Persist object.

HRESULT IRpKernel::GetSysScanner | ( | [out, retval] IRsSysScanner ** | pSysScanner | ) |

GetSysScanner

Returns System Scanner interface.

Returns:
  pSysScanner [out,retval] Interface to the System Scanner object.

HRESULT IRpKernel::GetLogger | ( | [out, retval] IRsLogger ** | ppLogger | ) |

GetLogger

Returns kernel logger.

Returns:
  ppLogger [out,retval] Interface to the kernel logger object.

HRESULT IRpKernel::GetKernelNode | ( | [out, retval] IRnKernel ** | pNode | ) |

GetKernelNode

Returns the root of the object-constraint graph.

Returns:
  pNode [out,retval] Interface to kernel node representing the root of the object-constraint graph.

HRESULT IRpKernel::SetKernelNode | ( | [in] IRsNode * | pNode | ) |

SetKernelNode

Assign new root of the object-constraint graph.

Parameters:

  | pNode | [in] Kernel node representing new root of the object-constraint graph.

HRESULT IRpKernel::GetSelectionManager | ( | [out, retval] IRsSelectionManager ** | ppSelMng | ) |

GetSelectionManager

Get the selection manager.

Returns:
  ppSelMng [out,retval] Interface to the selection manager.

HRESULT IRpKernel::GetNodeSelection | ( | [in] IRsSelectionNotification * | pNotify,
|  | [out, retval] IRdSelNodeSelection ** | ppSelection |
| ) |  |  |

GetNodeSelection

Get the node selection object.

- Method first checks the selection manager if the object is there and returns the existing one if yes.
- New, empty, node selection object is created and added to the manager if it does not exist.

Parameters:

  | pNotify | [in] Specifies the caller's notification object. This parameter can be NULL if the caller does not require the notification registration.

Returns:
  ppSelection [out,retval] Is filled with the valid and registered node selection object.

  method returns the error values of the called SelectionManager methods.

HRESULT IRpKernel::GetAcceleratorHandlerManager | ( | [out, retval] IRsAcceleratorHandlerManager ** | ppManager | ) |

GetAcceleratorHandlerManager

Get the Accelerator handler manager.

Returns:
  ppManager [out,retval] Interface to the Accelerator handler manager.

HRESULT IRpKernel::GetGlobalAcceleratorHandler | ( | [out, retval] IRsAcceleratorHandlerGlobal ** | ppHandler | ) |

GetGlobalAcceleratorHandler

Get the Global Accelerator handler.

Returns:
  ppHandler [out,retval] Interface to the Global Accelerator handler.

HRESULT IRpKernel::GetKernelFactory | ( | [out, retval] IRsKernelFactory ** | ppFactory | ) |

GetKernelFactory

Get the kernel factory.

Returns:
  ppFactory [out,retval] Interface to the Kernel factory.

HRESULT IRpKernel::GetPluginManager | ( | [out, retval] IRsPluginManager ** | ppPluginMng | ) |

GetPluginManager

Get plugin manager.

Returns:
  ppPluginMng [out,retval] Interface to the Plugin manager.

HRESULT IRpKernel::AddPackageLoadPath | ( | [in] BSTR | bsPath,
|  | [in] BOOL | bInsertToFront |
| ) |  |  |

AddPackageLoadPath

Add additional package load path.

Parameters:

  | bsPath | [in] .
  | bInsertToFront | [in] .

HRESULT IRpKernel::CreateBaseNode | ( | [in] IUnknown * | pOuter,
|  | [out, retval] IUnknown ** | ppBaseNode |
| ) |  |  |

CreateBaseNode

Creates Base Node.

- Used exclusively for aggregation, since each node must aggregate it.

Parameters:

  | pOuter | [in] Interface of outer object that aggregates base node.

Returns:
  ppBaseNode [out,retval] IUnknown iterface to newly created base node object.

HRESULT IRpKernel::CreateEncapsulator | ( | [in] IUnknown * | pOuter,
|  | [out, retval] IUnknown ** | ppEncapsulator |
| ) |  |  |

CreateEncapsulator

Creates Encapsulator Node used exclusively for aggregation.

Parameters:

  | pOuter | [in] Interface of outer object that aggregates encapsulator node.

Returns:
  ppEncapsulator [out,retval] IUnknown iterface to newly created encapsulator node object.

HRESULT IRpKernel::CreateEventLogSession | ( | [out, retval] IRsEventLogSession ** | ppLogSession | ) |

CreateEventLogSession

Create new object for recording events generated in the graph, used for automatic undo/redo support in commands.

Returns:
  ppLogSession [out,retval] Instance of new logging session object.

HRESULT IRpKernel::CreateBaseFnSet | ( | [in] IUnknown * | pOuter,
|  | [out, retval] IUnknown ** | ppBaseSet |
| ) |  |  |

CreateBaseFnSet

Creates base node function set object.

Parameters:

  | pOuter | [in] Outer interface for aggregation, can be NULL if not aggregated.

Returns:
  ppBaseSet [out,retval] IUnknown interface to the created instance of function set.

HRESULT IRpKernel::CreateKernelFnSet | ( | [in] IUnknown * | pOuter,
|  | [out, retval] IRfKernelSet ** | ppFn |
| ) |  |  |

CreateKernelFnSet

Creates kernel function set.

Parameters:

  | pOuter | [in] Outer interface for aggregation, can be NULL if not aggregated.

Returns:
  ppFn [out,retval] IUnknown interface to the created instance of function set.

HRESULT IRpKernel::CreateEncapsulatorFnSet | ( | [out, retval] IRfEncapsulatorSet ** | ppFn | ) |

CreateEncapsulatorFnSet

Creates encapsulator function set instance and returns the IRfEncapsulatorSet interface.

Returns:
  ppFn [out,retval] The primary interface to the created function set object.

HRESULT IRpKernel::CreateSystemNamedItem | ( | [out, retval] IUnknown ** | ppFn | ) |

CreateSystemNamedItem

Creates 'System' named item.

Returns:
  ppFn [out,retval] IUknown interface to newly created instance of system named item.

HRESULT IRpKernel::CreateBSEventFn | ( | [out, retval] IRfBSEventFn ** | ppEventFn | ) |

CreateBSEventFn

Creates BSEvent function set used for handling base system events.

Returns:
  ppEventFn [out,retval] Interface to the created BSEvent function set object.

HRESULT IRpKernel::CreateEncapsIt | ( | [out, retval] IRsEncapsIt ** | ppIt | ) |

CreateEncapsIt

Creates encapsulator iterator.

Returns:
  ppIt [out,retval] Interface to the created instance of iterator.

HRESULT IRpKernel::CreateNodeFilter | ( | [out, retval] IRsNodeFilter ** | ppNodeFilter | ) |

CreateNodeFilter

Creates new node filter object used for filtering nodes based on class id, name and connectors.

Returns:
  ppNodeFilter [out,retval] Interface to the created node filter object.

HRESULT IRpKernel::CreateConnectionHelper | ( | [out, retval] IRfConnection ** | ppConHelper | ) |

CreateConnectionHelper

Creates helper object for handling connections.

Returns:
  ppConHelper [out,retval] Interface to the created function set object.

HRESULT IRpKernel::ImportPackage | ( | [in] BSTR | inPackageFile | ) |

ImportPackage Imports specified package into system.

- It creates package instance, initializes and then registers it in the kernel.

Parameters:

  | inPackageFile | [in] File name of package.

HRESULT IRpKernel::RegisterPackage | ( | [in] IRsUnknownPackage * | pPackage | ) |

RegisterPackage Registers specified package in the kernel.

Parameters:

  | pPackage | [in] Interface to package object.

HRESULT IRpKernel::UnRegisterPackage | ( | [in] IRsUnknownPackage * | pPackage | ) |

UnRegisterPackage Removes registered package from the kernel.

Parameters:

  | pPackage | [in] Interface to package object.

HRESULT IRpKernel::FindPackage | ( | [in] GUID | id,
|  | [out, retval] IRsUnknownPackage ** | ppPackage |
| ) |  |  |

FindPackage

Searches for registered package by its GUID (i.e. DEF_GUIDNAME(CRpFileIOPck)).

Parameters:

  | id | [in] Unique identification of registered package.

Returns:
  ppPackage [out,retval] Interface to package object.

HRESULT IRpKernel::GetPackageModuleInstance | ( | [in] GUID | id,
|  | [out, retval] RtInstance * | pInstance |
| ) |  |  |

GetPackageModuleInstance

Finds package and returns its module instance.

Parameters:

  | id | [in] Unique identification of registered package.

Returns:
  pInstance [out,retval] Handle to module instance.

HRESULT IRpKernel::GetPackageResourceInstance | ( | [in] GUID | id,
|  | [out, retval] RtInstance * | pInstance |
| ) |  |  |

GetPackageResourceInstance

Finds package and returns its resource instance.

Parameters:

  | id | [in] Unique identification of registered package.

Returns:
  pInstance [out,retval] Handle to resource instance of the package.

HRESULT IRpKernel::EnumeratePackages | ( | [out, retval] IRsEnumPackage ** | ppEnumPackage | ) |

EnumeratePackages

Returns the package enumerator.

Returns:
  ppEnumPackage [out,retval] Interface to the package enumerator object.

HRESULT IRpKernel::GetPackageFileName | ( | [in] IRsUnknownPackage * | spUnkPackage,
|  | [out, retval] BSTR * | pbszFileName |
| ) |  |  |

GetPackageFileName

Returns filename of specified package.

Parameters:

  | spUnkPackage | [in] Unique identification of registered package.

Returns:
  pbszPackageName [out,retval] Filename of package.

HRESULT IRpKernel::IsShuttingDown | ( | [out, retval] RtBool * | bShuttingDown | ) |

IsShuttingDown

Returns true if system is being shut down.

Returns:
  bShuttingDown [out,retval] Set true if system is shutdowning otherwise false.

HRESULT IRpKernel::ShutDown | ( | void |  | ) |

ShutDown

Runs system shutdown sequence.

HRESULT IRpKernel::Run | ( | [in] BSTR | szInitScript | ) |

Run

Starts kernel with specified startup script.

Parameters:

  | szInitScript | [in] Initialization script command.

HRESULT IRpKernel::SendMessage | ( | [in] MSGID | msgId,
|  | [in] IRsUnknownMsg * | pMsg |
| ) |  |  |

SendMessage

Sends the system message to all registered packages.

Parameters:

  | msgId | [in] Message identification.
  | pMsg | [in] Custom message data.

HRESULT IRpKernel::ContextDestroy | ( | void |  | ) |

ContextDestroy

Destroys current context.

- It destroys whole object-contraint graph including the kernel node.

HRESULT IRpKernel::GetSysFactory | ( | [out, retval] IRsSysFactory ** | ppFactory | ) |

GetSysFactory

Returns interface to the System Factory.

Returns:
  ppFactory [out,retval] Interface to the System factory object.

HRESULT IRpKernel::GetSysCore | ( | [out, retval] IRsSysCore ** | ppSysCore | ) |

GetSysCore

Returns interface to the System Core.

Returns:
  ppSysCore [out,retval] Interface to the System Core object.

HRESULT IRpKernel::GetSysPersist | ( | [out, retval] IRsSysPersist ** | ppSysPersist | ) |

GetSysScanner

Returns interface to System Persist.

Returns:
  ppSysPersist [out,retval] Interface to the System Persist object.

HRESULT IRpKernel::GetSysScanner | ( | [out, retval] IRsSysScanner ** | pSysScanner | ) |

GetSysScanner

Returns System Scanner interface.

Returns:
  pSysScanner [out,retval] Interface to the System Scanner object.

HRESULT IRpKernel::GetLogger | ( | [out, retval] IRsLogger ** | ppLogger | ) |

GetLogger

Returns kernel logger.

Returns:
  ppLogger [out,retval] Interface to the kernel logger object.

HRESULT IRpKernel::GetKernelNode | ( | [out, retval] IRnKernel ** | pNode | ) |

GetKernelNode

Returns the root of the object-constraint graph.

Returns:
  pNode [out,retval] Interface to kernel node representing the root of the object-constraint graph.

HRESULT IRpKernel::SetKernelNode | ( | [in] IRsNode * | pNode | ) |

SetKernelNode

Assign new root of the object-constraint graph.

Parameters:

  | pNode | [in] Kernel node representing new root of the object-constraint graph.

HRESULT IRpKernel::GetSelectionManager | ( | [out, retval] IRsSelectionManager ** | ppSelMng | ) |

GetSelectionManager

Get the selection manager.

Returns:
  ppSelMng [out,retval] Interface to the selection manager.

HRESULT IRpKernel::GetNodeSelection | ( | [in] IRsSelectionNotification * | pNotify,
|  | [out, retval] IRdSelNodeSelection ** | ppSelection |
| ) |  |  |

GetNodeSelection

Get the node selection object.

- Method first checks the selection manager if the object is there and returns the existing one if yes.
- New, empty, node selection object is created and added to the manager if it does not exist.

Parameters:

  | pNotify | [in] Specifies the caller's notification object. This parameter can be NULL if the caller does not require the notification registration.

Returns:
  ppSelection [out,retval] Is filled with the valid and registered node selection object.

  method returns the error values of the called SelectionManager methods.

HRESULT IRpKernel::GetAcceleratorHandlerManager | ( | [out, retval] IRsAcceleratorHandlerManager ** | ppManager | ) |

GetAcceleratorHandlerManager

Get the Accelerator handler manager.

Returns:
  ppManager [out,retval] Interface to the Accelerator handler manager.

HRESULT IRpKernel::GetGlobalAcceleratorHandler | ( | [out, retval] IRsAcceleratorHandlerGlobal ** | ppHandler | ) |

GetGlobalAcceleratorHandler

Get the Global Accelerator handler.

Returns:
  ppHandler [out,retval] Interface to the Global Accelerator handler.

HRESULT IRpKernel::GetKernelFactory | ( | [out, retval] IRsKernelFactory ** | ppFactory | ) |

GetKernelFactory

Get the kernel factory.

Returns:
  ppFactory [out,retval] Interface to the Kernel factory.

HRESULT IRpKernel::GetPluginManager | ( | [out, retval] IRsPluginManager ** | ppPluginMng | ) |

GetPluginManager

Get plugin manager.

Returns:
  ppPluginMng [out,retval] Interface to the Plugin manager.

HRESULT IRpKernel::AddPackageLoadPath | ( | [in] BSTR | bsPath,
|  | [in] BOOL | bInsertToFront |
| ) |  |  |

AddPackageLoadPath

Add additional package load path.

Parameters:

  | bsPath | [in] .
  | bInsertToFront | [in] .

HRESULT IRpKernel::CreateBaseNode | ( | [in] IUnknown * | pOuter,
|  | [out, retval] IUnknown ** | ppBaseNode |
| ) |  |  |

CreateBaseNode

Creates Base Node.

- Used exclusively for aggregation, since each node must aggregate it.

Parameters:

  | pOuter | [in] Interface of outer object that aggregates base node.

Returns:
  ppBaseNode [out,retval] IUnknown iterface to newly created base node object.

HRESULT IRpKernel::CreateEncapsulator | ( | [in] IUnknown * | pOuter,
|  | [out, retval] IUnknown ** | ppEncapsulator |
| ) |  |  |

CreateEncapsulator

Creates Encapsulator Node used exclusively for aggregation.

Parameters:

  | pOuter | [in] Interface of outer object that aggregates encapsulator node.

Returns:
  ppEncapsulator [out,retval] IUnknown iterface to newly created encapsulator node object.

HRESULT IRpKernel::CreateEventLogSession | ( | [out, retval] IRsEventLogSession ** | ppLogSession | ) |

CreateEventLogSession

Create new object for recording events generated in the graph, used for automatic undo/redo support in commands.

Returns:
  ppLogSession [out,retval] Instance of new logging session object.

HRESULT IRpKernel::CreateBaseFnSet | ( | [in] IUnknown * | pOuter,
|  | [out, retval] IUnknown ** | ppBaseSet |
| ) |  |  |

CreateBaseFnSet

Creates base node function set object.

Parameters:

  | pOuter | [in] Outer interface for aggregation, can be NULL if not aggregated.

Returns:
  ppBaseSet [out,retval] IUnknown interface to the created instance of function set.

HRESULT IRpKernel::CreateKernelFnSet | ( | [in] IUnknown * | pOuter,
|  | [out, retval] IRfKernelSet ** | ppFn |
| ) |  |  |

CreateKernelFnSet

Creates kernel function set.

Parameters:

  | pOuter | [in] Outer interface for aggregation, can be NULL if not aggregated.

Returns:
  ppFn [out,retval] IUnknown interface to the created instance of function set.

HRESULT IRpKernel::CreateEncapsulatorFnSet | ( | [out, retval] IRfEncapsulatorSet ** | ppFn | ) |

CreateEncapsulatorFnSet

Creates encapsulator function set instance and returns the IRfEncapsulatorSet interface.

Returns:
  ppFn [out,retval] The primary interface to the created function set object.

HRESULT IRpKernel::CreateSystemNamedItem | ( | [out, retval] IUnknown ** | ppFn | ) |

CreateSystemNamedItem

Creates 'System' named item.

Returns:
  ppFn [out,retval] IUknown interface to newly created instance of system named item.

HRESULT IRpKernel::CreateBSEventFn | ( | [out, retval] IRfBSEventFn ** | ppEventFn | ) |

CreateBSEventFn

Creates BSEvent function set used for handling base system events.

Returns:
  ppEventFn [out,retval] Interface to the created BSEvent function set object.

HRESULT IRpKernel::CreateEncapsIt | ( | [out, retval] IRsEncapsIt ** | ppIt | ) |

CreateEncapsIt

Creates encapsulator iterator.

Returns:
  ppIt [out,retval] Interface to the created instance of iterator.

HRESULT IRpKernel::CreateNodeFilter | ( | [out, retval] IRsNodeFilter ** | ppNodeFilter | ) |

CreateNodeFilter

Creates new node filter object used for filtering nodes based on class id, name and connectors.

Returns:
  ppNodeFilter [out,retval] Interface to the created node filter object.

HRESULT IRpKernel::CreateConnectionHelper | ( | [out, retval] IRfConnection ** | ppConHelper | ) |

CreateConnectionHelper

Creates helper object for handling connections.

Returns:
  ppConHelper [out,retval] Interface to the created function set object.

## Property Documentation

IRsUnknownRunner** IRpKernel::DefaultRunner`[get]`

DefaultRunner

Gets interface of default runner.

Returns:
  pVal [out,retval] IRsUnknownRunner interface of runner object.

IRsUnknownRunner* IRpKernel::DefaultRunner`[set]`

DefaultRunner

Sets new default runner for kernel.

Parameters:

  | newVal | [in] IRsUnknownRunner interface of runner object.

IRsUnknownRunner** IRpKernel::DefaultRunner`[get]`

DefaultRunner

Gets interface of default runner.

Returns:
  pVal [out,retval] IRsUnknownRunner interface of runner object.

IRsUnknownRunner* IRpKernel::DefaultRunner`[set]`

DefaultRunner

Sets new default runner for kernel.

Parameters:

  | newVal | [in] IRsUnknownRunner interface of runner object.